   (DEFUN HAMILTCYCLE (LAMBDA (GRAPH)
   ; ஥ ⮭ 横:
   ; GRAPH   - , ।⠢ ன ᬥ 
   ;            樠⨢ ᯨ᪠,
   ; : ⮭ 横   ᯨ᪠ 設,
   ;            NIL, ᫨ ⮭ 横  
      (COND ( (NULL GRAPH) NIL )
            (  T  (COND ( (NULL (CDR GRAPH))
                              (LIST (CAAR GRAPH)))
                        (  T  (HC GRAPH (CAAR GRAPH)
                                  (LIST (CAAR GRAPH))
                                  (CDAR GRAPH)) )) ))
   ))
   ; ------------------------------------------
   (DEFUN HC (LAMBDA (GRAPH START VISITED SONS)
   ; GRAPH   - , ।⠢ ன ᬥ 
   ;            樠⨢ ᯨ᪠,
   ; START   - 設  - 砫 ⮭ 横,
   ; VISITED - ᯨ᮪ 饭 設 ,
   ; SONS    - ᯨ᮪ 設, ᬥ ࢮ 設  ᯨ᪥ VISITED
      (COND ( (NULL SONS) NIL )
            (  T  (COND ( (AND (MEMBER START SONS)
                               (EQ (LENGTH GRAPH)
                                   (LENGTH VISITED)))
                             (REVERSE VISITED) )
                        ( T (COND
                              ( (MEMBER (CAR SONS) VISITED)
                                  (HC GRAPH START VISITED
                                             (CDR SONS)) )
                              (  T  (OR (HC GRAPH START
                                            (CONS
                                              (CAR SONS) VISITED)
                                            (NEIGHBOUR3 (CAR SONS) GRAPH)
                                        )
                                        (HC
                                           GRAPH START VISITED
                                           (CDR SONS))) )) )) ))
   ))
   ; ---------------------------------
   (DEFUN NEIGHBOUR3 (LAMBDA (X GRAPH)
   ; 㭪 頥 ᯨ᮪ 設  GRAPH,
   ;            ᬥ  設 X
      (COND ( (NULL (ASSOC X GRAPH)) NIL )
            (  T  (CDR (ASSOC X GRAPH)) ))
   ))
   (RDS)
